;
(function ($) {
	$.jspager = function (el, options) {
		var jspager = $(el),
			vars = $.extend({}, $.jspager.defaults, options),
			currentPage = 1,
			methods = {};

		$.data(el, "jspager", jspager);

		methods = {
			init: function () {
				jspager.items = $(vars.selector);
				if (jspager.items.length > vars.itemsPerPage) {
					jspager.pages = Math.ceil(jspager.items.length / vars.itemsPerPage);
					jspager.render();
				}
			}
		};

		jspager.hideInvisible = function() {
			var counter = 0;
			jspager.items.each(function(item) {
				if (counter >= (currentPage - 1) * vars.itemsPerPage && counter < currentPage * vars.itemsPerPage) {
					$(jspager.items[item]).show();
				} else {
					$(jspager.items[item]).hide();
				}
				counter++;
			});
		}

		jspager.render = function() {
			jspager.hideInvisible();

			var holder = $("<ul></ul>");

			if (1 != currentPage) {
				holder.append(' <li class="page first"><a href="#page=1">первая</a></li>');
				holder.append(' <li class="page previous"><a href="#page=' + (currentPage*1 - 1) + '">назад</a></li>');
			}

			for (var i = 1; i <= jspager.pages; i++) {
				holder.append(' <li class="page' + (currentPage == i ? ' selected' : '') + '"><a href="#page=' + i + '">' + i + '</a></li>')
			}

			if (jspager.pages != currentPage) {
				holder.append(' <li class="page next"><a href="#page=' + (currentPage*1 + 1) + '">вперед</a></li>');
				holder.append(' <li class="page last"><a href="#page=' + jspager.pages + '">последняя</a></li>');
			}

			jspager.html(holder);

			holder.find('li').bind("click", function() {
				var current = $(this).children('a').attr('href').substr(6);
				if (current > jspager.pages) {
					current = jspager.pages;
				}
				currentPage = current;
				jspager.render();
			});
		}

		methods.init();
	}

	$.jspager.defaults = {
		itemsPerPage: 10,
		selector: "div.data-items > div.data-item"
	};

	$.fn.jspager = function(options) {
		if (options === undefined) options = {};

		if (typeof options === "object") {
			return this.each(function() {
				var $this = $(this),
					selector = (options.selector) ? options.selector : "div.data-items > div.data-item",
					$items = $(selector);

				if ($this.data('jspager') == undefined) {
					new $.jspager(this, options);
				}
			});
		} else {
			var $jspager = $(this).data('jspager');
		}
	}
})(jQuery);